=== debian/changelog ===
qtpdwidgets2 (2.0.0.2.g61d1554-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100
