=== debian/control ===
Source: qtpdwidgets2
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: dh-exec (>= 0.3), debhelper (>= 9), qtchooser, qtbase5-dev, libqt5svg5-dev, qttools5-dev, qttools5-dev-tools, libqtpdcom1-dev, cmake (>= 3.10)
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.etherlab.org

Package: libqtpdwidgets2-dev
Section: libdevel
Architecture: any
Depends: libqtpdwidgets2 (= ${binary:Version}), libqtpdcom1-dev, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 Header files

Package: libqtpdwidgets2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.

Package: libqtpdwidgets2-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libqtpdwidgets2 (= ${binary:Version}), ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 This package contains the debugging symbols for libpqtpdwidgets
