=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

QTPDWIDGETS_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}"

%:
	dh $@ --parallel

.PHONY:
	override_dh_strip

override_dh_install:
	dh_install
	# workaround for Ubuntu 20.04 where headers are installed twice
	rm debian/tmp/usr/include/*.h || true

override_dh_strip:
	dh_strip --dbg-package=libqtpdwidgets2-dbg

override_dh_missing:
	dh_missing --fail-missing

override_dh_shlibdeps:
	dh_shlibdeps -l $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
