=== debian/changelog ===
qtpdwidgets2 (2.3.2.g888405b-0+322.1) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Mon, 26 May 2025 14:20:47 +0000

qtpdwidgets2 (2.3.2.g888405b-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100
