## qtpdwidgets2 2.3.3.g18681dc

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 cmake_minimum_required(VERSION 3.10)
 
-project(QtPdWidgets2 VERSION 2.3.2) # Do not forget to update NEWS
+project(QtPdWidgets2 VERSION 2.3.3) # Do not forget to update NEWS
 
 set(SOVERSION 3)
