=== debian/changelog ===
qtpdwidgets2 (2.3.3.g18681dc-0+324.5) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Sun, 20 Jul 2025 05:41:37 +0000

qtpdwidgets2 (2.3.3.g18681dc-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100
