=== debian/control ===
Source: qtpdwidgets2
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: dh-exec (>= 0.3), debhelper (>= 9), qtchooser, qt6-5compat-dev, qt6-base-dev, qt6-svg-dev, qt6-tools-dev, qt6-tools-dev-tools, libqt6pdcom1-dev, cmake (>= 3.10), python3, python3-yaml, libqt6opengl6-dev
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.etherlab.org

Package: libqt6pdwidgets2-dev
Section: libdevel
Architecture: any
Depends: libqtpdwidgets2-headers (= ${binary:Version}), libqt6pdwidgets2-3 (= ${binary:Version}), libqt6pdcom1-dev, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 Header files

Package: libqt6pdwidgets2-3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
