=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt6

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


# be strict regarding symbol file
export DPKG_GENSYMBOLS_CHECK_LEVEL := 3

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

QTPDWIDGETS_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}" -DUSE_SYMBOL_VERSIONING=1 -DUSE_QT6=1 -DPUT_QT_MAJOR_INTO_LIBNAME=1

%:
	dh $@ --parallel

.PHONY:
	override_dh_strip

override_dh_install:
	dh_install
	python3 symbol-versioning/symbol_version_tool.py -i Qt6PdWidgets.map.yaml --library $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQt6PdWidgets2.so.3 \
		-o debian/libqt6pdwidgets2-3.symbols GenerateDebianSymbolsFile
