## qtpdwidgets2 2.3.4.gda637bb

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 cmake_minimum_required(VERSION 3.10)
 
-project(QtPdWidgets2 VERSION 2.3.3) # Do not forget to update NEWS
+project(QtPdWidgets2 VERSION 2.3.4) # Do not forget to update NEWS.md
 
 set(SOVERSION 3)
