=== example/CMakeLists.txt ===
--- 
+++ 
@@ -24,11 +24,32 @@
 
 project(pdwidgetsexample)
 
+option(USE_QT6 "Use Qt6 instead of Qt5" OFF)
+option(PUT_QT_MAJOR_INTO_LIBNAME "Put Qt Major Version into Library Name" OFF)
+
+if(USE_QT6)
+    set(Qt Qt6)
+else()
+    set(Qt Qt5)
+endif()
+
+if (PUT_QT_MAJOR_INTO_LIBNAME)
+    set(Widgets "${Qt}PdWidgets2")
+else()
+    set(Widgets "QtPdWidgets2")
+endif()
+
 # load Qt
-find_package(Qt5 REQUIRED COMPONENTS Gui Network Quick Svg Widgets Xml)
+find_package(${Qt} REQUIRED COMPONENTS Gui Network Quick Svg Widgets Xml)
 # load PdWidgets
-if (NOT TARGET EtherLab::QtPdWidgets2)
-    find_package(QtPdWidgets2 REQUIRED)
+if (NOT TARGET EtherLab::${Widgets})
+    find_package(${Widgets} REQUIRED)
+endif()
+
+if (USE_QT6)
+    qt6_add_resources(EXAMPLE_QRC_SOURCES example.qrc)
+else()
+    qt5_add_resources(EXAMPLE_QRC_SOURCES example.qrc)
 endif()
 
 add_executable(${PROJECT_NAME}
@@ -37,7 +58,7 @@
     MainWindow.cpp
     main.cpp
 
-    example.qrc
+    ${EXAMPLE_QRC_SOURCES}
 )
 
 # enable moc, uic and rcc
@@ -50,7 +71,7 @@
 
 # link against Qt and PdWidgets
 target_link_libraries(${PROJECT_NAME} PUBLIC
-    EtherLab::QtPdWidgets2
-    Qt5::Gui
-    Qt5::Widgets
+    EtherLab::${Widgets}
+    ${Qt}::Gui
+    ${Qt}::Widgets
 )
