=== debian/changelog ===
qtpdwidgets2 (2.3.4.gda637bb-0+327.1) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Thu, 16 Oct 2025 16:27:54 +0000

qtpdwidgets2 (2.3.4.gda637bb-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100
