=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export QT_SELECT := qt6
+export QT_SELECT := qt5
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
@@ -28,7 +28,7 @@
 QTPDWIDGETS_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}" -DUSE_SYMBOL_VERSIONING=1 -DUSE_QT6=1 -DPUT_QT_MAJOR_INTO_LIBNAME=1
+	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}" -DUSE_SYMBOL_VERSIONING=1
 
 %:
 	dh $@ --parallel
@@ -38,5 +38,5 @@
 
 override_dh_install:
 	dh_install
-	python3 symbol-versioning/symbol_version_tool.py -i Qt6PdWidgets.map.yaml --library $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQt6PdWidgets2.so.3 \
-		-o debian/libqt6pdwidgets2-3.symbols GenerateDebianSymbolsFile
+	python3 symbol-versioning/symbol_version_tool.py -i Qt5PdWidgets.map.yaml --library $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQtPdWidgets2.so.3 \
+		-o debian/libqtpdwidgets2-3.symbols GenerateDebianSymbolsFile
